VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsFiles"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : clsFiles
' DateTime  : 28/12/2006 22:13
' Author    : Vb System Library
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
' Purpose   : Grer les fichiers
'---------------------------------------------------------------------------------------

Option Explicit

' Le type FileVersionInfos
Public Type FileVersionInfos
    FileVersion As String
    FileDescription As String
    CompanyName As String
    InternalName As String
    Copyright As String
    OriginalFileName As String
    ProductName As String
    ProductVersion As String
End Type


' Liste des dossiers spciaux
Public Enum SPECIAL_FOLDER_TYPE
    CSIDL_DESKTOP = &H0                 '{desktop}
    CSIDL_INTERNET = &H1                'Internet Explorer (icon on desktop)
    CSIDL_PROGRAMS = &H2                'Start Menu\Programs
    CSIDL_CONTROLS = &H3                'My Computer\Control Panel
    CSIDL_PRINTERS = &H4                'My Computer\Printers
    CSIDL_PERSONAL = &H5                'My Documents
    CSIDL_FAVORITES = &H6               '{user}\Favourites
    CSIDL_STARTUP = &H7                 'Start Menu\Programs\Startup
    CSIDL_RECENT = &H8                  '{user}\Recent
    CSIDL_SENDTO = &H9                  '{user}\SendTo
    CSIDL_BITBUCKET = &HA               '{desktop}\Recycle Bin
    CSIDL_STARTMENU = &HB               '{user}\Start Menu
    CSIDL_DESKTOPDIRECTORY = &H10       '{user}\Desktop
    CSIDL_DRIVES = &H11                 'My Computer
    CSIDL_NETWORK = &H12                'Network Neighbourhood
    CSIDL_NETHOOD = &H13                '{user}\nethood
    CSIDL_FONTS = &H14                  'windows\fonts
    CSIDL_TEMPLATES = &H15
    CSIDL_COMMON_STARTMENU = &H16       'All Users\Start Menu
    CSIDL_COMMON_PROGRAMS = &H17        'All Users\Programs
    CSIDL_COMMON_STARTUP = &H18         'All Users\Startup
    CSIDL_COMMON_DESKTOPDIRECTORY = &H19 'All Users\Desktop
    CSIDL_APPDATA = &H1A                '{user}\Application Data
    CSIDL_PRINTHOOD = &H1B              '{user}\PrintHood
    CSIDL_LOCAL_APPDATA = &H1C          '{user}\Local Settings\Application Data (non roaming)
    CSIDL_ALTSTARTUP = &H1D             'non localized startup
    CSIDL_COMMON_ALTSTARTUP = &H1E      'non localized common startup
    CSIDL_COMMON_FAVORITES = &H1F
    CSIDL_INTERNET_CACHE = &H20
    CSIDL_COOKIES = &H21
    CSIDL_HISTORY = &H22
    CSIDL_COMMON_APPDATA = &H23          'All Users\Application Data
    CSIDL_WINDOWS = &H24                 'GetWindowsDirectory()
    CSIDL_SYSTEM = &H25                  'GetSystemDirectory()
    CSIDL_PROGRAM_FILES = &H26           'C:\Program Files
    CSIDL_MYPICTURES = &H27              'C:\Program Files\My Pictures
    CSIDL_PROFILE = &H28                 'USERPROFILE
    CSIDL_SYSTEMX86 = &H29               'x86 system directory on RISC
    CSIDL_PROGRAM_FILESX86 = &H2A        'x86 C:\Program Files on RISC
    CSIDL_PROGRAM_FILES_COMMON = &H2B    'C:\Program Files\Common
    CSIDL_PROGRAM_FILES_COMMONX86 = &H2C 'x86 Program Files\Common on RISC
    CSIDL_COMMON_TEMPLATES = &H2D        'All Users\Templates
    CSIDL_COMMON_DOCUMENTS = &H2E        'All Users\Documents
    CSIDL_COMMON_ADMINTOOLS = &H2F       'All Users\Start Menu\Programs\Administrative Tools
    CSIDL_ADMINTOOLS = &H30              '{user}\Start Menu\Programs\Administrative Tools
End Enum



'---------------------------------------------------------------------------------------
' Procedure : FileExists
' DateTime  : 29/12/2006 15:22
' Author    : Vb System Library
' Purpose   : Renvoie TRUE si le fichier ou dossier existe, FALSE dans le cas contraire
' Params    : FullPath : Chemin d'accs au fichier
'---------------------------------------------------------------------------------------
Public Function FileExists(ByRef FullPath As String) As Boolean
    FileExists = (GetFileAttributes(FullPath) <> FILE_INVALID_ATTRIBUTES)
End Function


'---------------------------------------------------------------------------------------
' Procedure : KillFile
' DateTime  : 31/12/2006 01:23
' Author    : Vb System Library
' Purpose   : Supprime un fichier
' Params    : FullPath : Chemin d'accs au fichier
'---------------------------------------------------------------------------------------
Public Function KillFile(ByRef FullPath As String)
    ' Supprime un attribut qui empecherait la suppression
    SetFileAttributes FullPath, FILE_ATTRIBUTE_NORMAL
    KillFile = DeleteFile(FullPath)
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetFileExtension
' DateTime  : 31/12/2006 01:29
' Author    : Vb System Library
' Purpose   : Renvoie l'extension du fichier
' Params    : FileName : Nom du fichier
'---------------------------------------------------------------------------------------
Public Function GetFileExtension(ByVal FileName As String) As String
    Dim Ptr As Long
    Ptr = PathFindExtension(FileName)
    GetFileExtension = String$(lstrlen(Ptr), 0)
    lstrcpy ByVal GetFileExtension, ByVal Ptr
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetFileNameFromFullPath
' DateTime  : 31/12/2006 01:22
' Author    : Vb System Library
' Purpose   : Permet de rcuprer seulement le nom de fichier  partir du chemin d'accs complet
' Params    : FullPath : Chemin d'accs au fichier
'---------------------------------------------------------------------------------------
Public Function GetFileNameFromFullPath(ByVal FullPath As String) As String
    GetFileNameFromFullPath = Right$(FullPath, Len(FullPath) - InStrRev(FullPath, "\"))
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetPathFromFullPath
' DateTime  : 31/12/2006 01:22
' Author    : Vb System Library
' Purpose   : Permet de rcuprer seulement le dossier  partir du chemin d'accs au
'               fichier (avec extension)
'               Exemple : Renvoie "C:\Dossier\" avec FullPath="C:\Dossier\Fichier.exe"
' Params    :
'---------------------------------------------------------------------------------------
Public Function GetPathFromFullPath(ByVal FullPath As String) As String
    GetPathFromFullPath = Left$(FullPath, InStrRev(FullPath, "\"))
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetFileVersionInfos
' DateTime  : 28/12/2006 22:13
' Author    : Vb System Library
' Purpose   : Rcuprer une information sur un fichier
' Params    :   sFileName : Chemin d'accs au fichier
'               Renvoie un type FileVersionInfos
'---------------------------------------------------------------------------------------
Public Function GetFileVersionInfos(ByVal sFileName As String) As FileVersionInfos
    Dim Vffi As VS_FIXEDFILEINFO  ' version info structure
    Dim Buffer() As Byte          ' buffer for info ressource
    Dim pData As Long             ' pointer to info data
    Dim lDataLen As Long          ' length of info pointed at by pData
    Dim cpl(0 To 3) As Byte       ' buffer for code page & language
    Dim cplstr As String          ' 8-digit hex string of cpl
    Dim strVersionInfo As String
    ' Prpare la structure
    GetFileVersionInfos.CompanyName = ""
    GetFileVersionInfos.Copyright = ""
    GetFileVersionInfos.FileDescription = ""
    GetFileVersionInfos.FileVersion = ""
    GetFileVersionInfos.InternalName = ""
    GetFileVersionInfos.OriginalFileName = ""
    GetFileVersionInfos.ProductName = ""
    GetFileVersionInfos.ProductVersion = ""
    ' Contrle si le fichier contient des informations rcuprables
    lDataLen = GetFileVersionInfoSize(sFileName, pData)
    If lDataLen = 0 Then
        Exit Function
    End If
    ReDim Buffer(0 To lDataLen - 1) As Byte
    ' Get the version information resource.
    If GetFileVersionInfo(sFileName, 0, lDataLen, Buffer(0)) <> 0 Then
        ' Get a pointer to a structure that holds a bunch of data.
        If VerQueryValue(Buffer(0), "\", pData, lDataLen) <> 0 Then
            ' Copy that structure into the one we can access.
            MoveMemory Vffi, ByVal pData, lDataLen
            ' ---------------------------------------
            ' Rcupration de la version du fichier
            GetFileVersionInfos.FileVersion = Trim(Str(HIWORD(Vffi.dwFileVersionMS))) & "." & _
                                            Trim(Str(LOWORD(Vffi.dwFileVersionMS))) & "." & _
                                            Trim(Str(HIWORD(Vffi.dwFileVersionLS))) & "." & _
                                            Trim(Str(LOWORD(Vffi.dwFileVersionLS)))
            ' Rcupration du code page et du langage
            If VerQueryValue(Buffer(0), "\VarFileInfo\Translation", pData, lDataLen) <> 0 Then
                ' Copy that information into the byte array.
                MoveMemory cpl(0), ByVal pData, 4
                ' Convert those four bytes into a 8-digit hexadecimal string.
                cplstr = FixedHex(cpl(1), 2) & FixedHex(cpl(0), 2) & FixedHex(cpl(3), 2) & FixedHex(cpl(2), 2)
                ' cplstr contient maintenant le code page et le langage
                ' ---------------------------------------
                ' Rcupration des autres infos
                strVersionInfo = "CompanyName"
                If VerQueryValue(Buffer(0), "\StringFileInfo\" & cplstr & "\" & strVersionInfo, pData, lDataLen) <> 0 Then
                        If lDataLen > 0 Then lDataLen = lDataLen - 1
                        GetFileVersionInfos.CompanyName = Space(lDataLen)
                        lstrcpy GetFileVersionInfos.CompanyName, pData
                End If
                strVersionInfo = "FileDescription"
                If VerQueryValue(Buffer(0), "\StringFileInfo\" & cplstr & "\" & strVersionInfo, pData, lDataLen) <> 0 Then
                        If lDataLen > 0 Then lDataLen = lDataLen - 1
                        GetFileVersionInfos.FileDescription = Space(lDataLen)
                        lstrcpy GetFileVersionInfos.FileDescription, pData
                End If
                strVersionInfo = "FileVersion"
                If VerQueryValue(Buffer(0), "\StringFileInfo\" & cplstr & "\" & strVersionInfo, pData, lDataLen) <> 0 Then
                        If lDataLen > 0 Then lDataLen = lDataLen - 1
                        GetFileVersionInfos.FileVersion = Space(lDataLen)
                        lstrcpy GetFileVersionInfos.FileVersion, pData
                End If
                strVersionInfo = "InternalName"
                If VerQueryValue(Buffer(0), "\StringFileInfo\" & cplstr & "\" & strVersionInfo, pData, lDataLen) <> 0 Then
                        If lDataLen > 0 Then lDataLen = lDataLen - 1
                        GetFileVersionInfos.InternalName = Space(lDataLen)
                        lstrcpy GetFileVersionInfos.InternalName, pData
                End If
                strVersionInfo = "LegalCopyright"
                If VerQueryValue(Buffer(0), "\StringFileInfo\" & cplstr & "\" & strVersionInfo, pData, lDataLen) <> 0 Then
                        If lDataLen > 0 Then lDataLen = lDataLen - 1
                        GetFileVersionInfos.Copyright = Space(lDataLen)
                        lstrcpy GetFileVersionInfos.Copyright, pData
                End If
                strVersionInfo = "OriginalFileName"
                If VerQueryValue(Buffer(0), "\StringFileInfo\" & cplstr & "\" & strVersionInfo, pData, lDataLen) <> 0 Then
                        If lDataLen > 0 Then lDataLen = lDataLen - 1
                        GetFileVersionInfos.OriginalFileName = Space(lDataLen)
                        lstrcpy GetFileVersionInfos.OriginalFileName, pData
                End If
                strVersionInfo = "ProductName"
                If VerQueryValue(Buffer(0), "\StringFileInfo\" & cplstr & "\" & strVersionInfo, pData, lDataLen) <> 0 Then
                        If lDataLen > 0 Then lDataLen = lDataLen - 1
                        GetFileVersionInfos.ProductName = Space(lDataLen)
                        lstrcpy GetFileVersionInfos.ProductName, pData
                End If
                strVersionInfo = "ProductVersion"
                If VerQueryValue(Buffer(0), "\StringFileInfo\" & cplstr & "\" & strVersionInfo, pData, lDataLen) <> 0 Then
                        If lDataLen > 0 Then lDataLen = lDataLen - 1
                        GetFileVersionInfos.ProductVersion = Space(lDataLen)
                        lstrcpy GetFileVersionInfos.ProductVersion, pData
                End If
            End If
        End If
    End If
End Function
' Creation d'une chaine Hexadecimale pour reprsenter un nombre
Private Function FixedHex(ByVal hexval As Long, ByVal nDigits As Long) As String
        FixedHex = Right("00000000" & Hex(hexval), nDigits)
End Function
Private Function HIWORD(ByVal dwValue As Long) As Long
        Dim hexstr As String
        hexstr = Right("00000000" & Hex(dwValue), 8)
        HIWORD = CLng("&H" & Left(hexstr, 4))
End Function
Private Function LOWORD(ByVal dwValue As Long) As Long
        Dim hexstr As String
        hexstr = Right("00000000" & Hex(dwValue), 8)
        LOWORD = CLng("&H" & Right(hexstr, 4))
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetAssociatedExecutableProgram
' DateTime  : 07/02/2007 15:05
' Author    : Vb System Library
' Purpose   : Renvoie le programme associ  un fichier
' Params    : FullPath : Chemin d'accs au fichier
'---------------------------------------------------------------------------------------
Public Function GetAssociatedExecutableProgram(ByVal FullPath As String) As String
    Dim sBuf As String
    ' Cration d'un buffer
    sBuf = String$(255, 0)
    ' trouve l'xcutable associ
    FindExecutable FullPath, vbNullString, sBuf
    ' formate la string
    GetAssociatedExecutableProgram = Left$(sBuf, InStr(sBuf, vbNullChar) - 1)
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetFileSize
' DateTime  : 07/02/2007 15:07
' Author    : Vb System Library
' Purpose   : Renvoie la taille d'un fichier, mme si celle ci est suprieure  4Go (long)
' Params    : FullPath : Chemin d'accs au fichier
'---------------------------------------------------------------------------------------
Public Function GetFileSize(ByVal FullPath As String) As Currency
    Dim lngFile As Long
    Dim curSize As Currency
    'obtient le handle du fichier
    lngFile = CreateFile(FullPath, GENERIC_READ, FILE_SHARE_WRITE Or FILE_SHARE_READ, ByVal 0&, OPEN_EXISTING, ByVal 0&, ByVal 0&)
    'obtient la taille par API
    GetFileSizeEx lngFile, curSize
    'ferme le handle ouvert
    CloseHandle lngFile
    GetFileSize = curSize * 10000 'multiplie par 10^4 pour obtenir un nombre entier
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetSpecialFolder
' DateTime  : 07/02/2007 15:09
' Author    : Vb System Library
' Purpose   : Renvoie le chemin d'accs  des dossiers spciaux de windows
' Params    : Folder : un Enum permettant de prciser quel dossier spcial on veut
'               hWnd : optionnel, le handle de la fenetre propritaire
'---------------------------------------------------------------------------------------
Public Function GetSpecialFolder(Folder As SPECIAL_FOLDER_TYPE, Optional ByVal hWnd As Long) As String
    Dim ret As Long
    Dim sPath As String
    Dim IDL As ITEMIDLIST
    'obtient le path
    ret = SHGetSpecialFolderLocation(hWnd, Folder, IDL)
    If ret = 0 Then
        'cration d'un buffer
        sPath = Space$(512) '512 > MAX_PATH
        'obtient le path depuis l'itemidlist
        ret = SHGetPathFromIDList(ByVal IDL.mkid.cb, ByVal sPath)
        'formate le texte
        GetSpecialFolder = Left$(sPath, InStr(sPath, vbNullChar) - 1)
        Exit Function
    End If
    GetSpecialFolder = vbNullString
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetFileIcon16
' DateTime  : 07/02/2007 15:26
' Author    : Vb System Library
' Purpose   : Rcupre l'icone d'un fichier en 16*16
' Params    : FullPath : Chemin d'accs au fichier
'---------------------------------------------------------------------------------------
Public Function GetFileIcon16(ByRef FullPath As String) As IPictureDisp
    ' La variable qui va contenir l'identifiant de l'icne
    Dim hIco        As Long
    Dim hIcon       As Long
    Dim SHFinfo     As SHFILEINFO
    Dim clsV        As New clsVarious
    hIco = SHGetFileInfo(FullPath, 0&, SHFinfo, Len(SHFinfo), DJM_SMALLICON)
    hIcon = ImageList_GetIcon(hIco, SHFinfo.iIcon, 0)
    Set GetFileIcon16 = clsV.GetIconFromHandle(hIcon)
    ' Efface l'icne qui a t extrait
    DestroyIcon hIcon
    Set clsV = Nothing
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetFileIcon32
' DateTime  : 07/02/2007 15:26
' Author    : Vb System Library
' Purpose   : Rcupre l'icone d'un fichier en 32*32
' Params    : FullPath : Chemin d'accs au fichier
'---------------------------------------------------------------------------------------
Public Function GetFileIcon32(ByRef FullPath As String) As IPictureDisp
    ' La variable qui va contenir l'identifiant de l'icne
    Dim hIcon       As Long
    Dim clsV        As New clsVarious
    hIcon = ExtractAssociatedIcon(App.hInstance, FullPath, 2)
    Set GetFileIcon32 = clsV.GetIconFromHandle(hIcon)
    ' Efface l'icne qui a t extrait
    DestroyIcon hIcon
    Set clsV = Nothing
End Function


'---------------------------------------------------------------------------------------
' Procedure : PaintFileIcon16
' DateTime  : 10/04/2007 22:09
' Author    : Vb System Library
' Purpose   : Dessine l'icone d'un fichier en 16*16 dans l'objet point par le hDC
' Params    : FullPath : Chemin d'accs au fichier
'               hDC : hDC de l'objet dans lequel doit etre paint l'icone
'---------------------------------------------------------------------------------------
Public Function PaintFileIcon16(ByVal FullPath As String, ByVal hDC As Long)

    Dim vSHFI As SHFILEINFO
    Dim vAttr As Long
    Dim hImgSmall As Long

    vAttr = BASIC_SHGFI_FLAGS Or SHGFI_SMALLICON
    hImgSmall = SHGetFileInfo(FullPath, 0&, vSHFI, Len(vSHFI), vAttr)

    If vSHFI.iIcon = 0 Then
        vAttr = BASIC_SHGFI_FLAGS Or SHGFI_SMALLICON Or SHGFI_USEFILEATTRIBUTES 'Or SHGFI_TYPENAME  'Or SHGFI_ICON 'SHGFI_LARGEICON
        hImgSmall = SHGetFileInfo(FullPath, 0&, vSHFI, Len(vSHFI), vAttr)
    End If
    
    Call ImageList_Draw(hImgSmall, vSHFI.iIcon, hDC, 0, 0, &H1)

End Function


'---------------------------------------------------------------------------------------
' Procedure : PaintFileIcon32
' DateTime  : 10/04/2007 22:09
' Author    : Vb System Library
' Purpose   : Dessine l'icone d'un fichier en 32*32 dans l'objet point par le hDC
' Params    : FullPath : Chemin d'accs au fichier
'               hDC : hDC de l'objet dans lequel doit etre paint l'icone
'---------------------------------------------------------------------------------------
Public Function PaintFileIcon32(ByVal FullPath As String, ByVal hDC As Long)

    Dim vSHFI As SHFILEINFO
    Dim vAttr As Long
    Dim hImgSmall As Long

    vAttr = BASIC_SHGFI_FLAGS Or SHGFI_ICON
    hImgSmall = SHGetFileInfo(FullPath, 0&, vSHFI, Len(vSHFI), vAttr)

    If vSHFI.iIcon = 0 Then
        vAttr = BASIC_SHGFI_FLAGS Or SHGFI_ICON Or SHGFI_USEFILEATTRIBUTES 'Or SHGFI_TYPENAME  'Or SHGFI_ICON 'SHGFI_LARGEICON
        hImgSmall = SHGetFileInfo(FullPath, 0&, vSHFI, Len(vSHFI), vAttr)
    End If
    
    Call ImageList_Draw(hImgSmall, vSHFI.iIcon, hDC, 0, 0, &H1)

End Function


'---------------------------------------------------------------------------------------
' Procedure : GetWindowsPath
' DateTime  : 11/04/2007 00:29
' Author    : Vb System Library
' Purpose   : Renvoie le chemin d'accs au dossier d'installation de windows
' Params    :
'---------------------------------------------------------------------------------------
Public Function GetWindowsPath() As String
    Dim sSave   As String
    Dim ret     As Long
    sSave = Space$(255)
    ret = GetWindowsDirectory(sSave, 255)
    GetWindowsPath = Left$(sSave, ret)
End Function
