VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPrivileges"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : clsDebug
' DateTime  : 22/11/2006 23:04
' Author    : Vb System Library
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
' Purpose   : Regroupe les fonctions permettants de manipuler les privilges de processus
'---------------------------------------------------------------------------------------
Option Explicit


'---------------------------------------------------------------------------------------
' Procedure : EnableDebugPrivileges
' DateTime  : 22/11/2006 23:05
' Author    : Vb System Library
' Purpose   : donne le privilege Debug  l'application
'             (permet d'accder  tout les processus avec OpenProcess)
'---------------------------------------------------------------------------------------
Public Sub EnableDebugPrivileges()

    Dim PID As Long
    'obtient le handle de ce process
    PID = GetCurrentProcess
    'change les droits de cette application
    SetPrivilege PID, SE_DEBUG_NAME, True

End Sub


'---------------------------------------------------------------------------------------
' Procedure : SetPrivilege
' DateTime  : 04/04/2007 20:35
' Author    : Vb System Library
' Purpose   : Donne un niveau de privilge  un processus
' Params    : ProcessID : ID du processus
'---------------------------------------------------------------------------------------
Public Function SetPrivilege(ByVal ProcessId As Long, ByVal seName As String, ByVal Status As Boolean) As Boolean
    
    Dim hProcess            As Long
    Dim hProcessToken       As Long
    Dim Ret                 As Long
    Dim p_lngToken          As Long
    Dim p_lngBufferLen      As Long
    Dim p_typLUID           As LUID
    Dim p_typTokenPriv      As TOKEN_PRIVILEGES
    Dim p_typPrevTokenPriv  As TOKEN_PRIVILEGES
    
    hProcess = OpenProcess(PROCESS_ALL_ACCESS, False, ProcessId)
    If hProcess Then
        hProcessToken = OpenProcessToken(hProcess, TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY, p_lngToken)
        If hProcessToken Then
            Ret = LookupPrivilegeValue(0&, seName, p_typLUID)
            If Ret Then
                p_typTokenPriv.PrivilegeCount = 1
                p_typTokenPriv.Privileges.Attributes = GetStatusLong(Status)
                p_typTokenPriv.Privileges.pLuid = p_typLUID
                SetPrivilege = (AdjustTokenPrivileges(p_lngToken, False, p_typTokenPriv, Len(p_typPrevTokenPriv), p_typPrevTokenPriv, p_lngBufferLen) = 1)
            End If
        End If
    End If
    
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetFullPrivilegeName
' DateTime  : 04/04/2007 20:36
' Author    : Vb System Library
' Purpose   : Renvoie le nom du privilge
' Params    :
'---------------------------------------------------------------------------------------
Public Function GetFullPrivilegeName(ByVal sName As String) As String

    Select Case UCase(sName)
        Case UCase("Audit"):                GetFullPrivilegeName = SE_AUDIT_NAME
        Case UCase("Backup"):               GetFullPrivilegeName = SE_BACKUP_NAME
        Case UCase("ChangeNotify"):         GetFullPrivilegeName = SE_CHANGE_NOTIFY_NAME
        Case UCase("CreatePagefile"):       GetFullPrivilegeName = SE_CREATE_PAGEFILE_NAME
        Case UCase("CreatePermanent"):      GetFullPrivilegeName = SE_CREATE_PERMANENT_NAME
        Case UCase("CreateToken"):          GetFullPrivilegeName = SE_CREATE_TOKEN_NAME
        Case UCase("Debug"):                GetFullPrivilegeName = SE_DEBUG_NAME
        Case UCase("RemoteShutdown"):       GetFullPrivilegeName = SE_REMOTE_SHUTDOWN_NAME
        Case UCase("ProfileSingleProcess"): GetFullPrivilegeName = SE_PROF_SINGLE_PROCESS_NAME
        Case UCase("Restore"):              GetFullPrivilegeName = SE_RESTORE_NAME
        Case UCase("Security"):             GetFullPrivilegeName = SE_SECURITY_NAME
        Case UCase("Shutdown"):             GetFullPrivilegeName = SE_SHUTDOWN_NAME
        Case UCase("SystemEnvironment"):    GetFullPrivilegeName = SE_SYSTEM_ENVIRONMENT_NAME
        Case UCase("SystemProfile"):        GetFullPrivilegeName = SE_SYSTEM_PROFILE_NAME
        Case UCase("Systemtime"):           GetFullPrivilegeName = SE_SYSTEMTIME_NAME
        Case UCase("TakeOwnership"):        GetFullPrivilegeName = SE_TAKE_OWNERSHIP_NAME
        Case UCase("Tcb"):                  GetFullPrivilegeName = SE_TCB_NAME
        Case UCase("ManageVolume"):         GetFullPrivilegeName = SE_MANAGE_VOLUME_NAME
        Case UCase("IncreaseBasePriority"): GetFullPrivilegeName = SE_INC_BASE_PRIORITY_NAME
        Case UCase("IncreaseQuota"):        GetFullPrivilegeName = SE_INCREASE_QUOTA_NAME
        Case UCase("LockMemory"):           GetFullPrivilegeName = SE_LOCK_MEMORY_NAME
        Case UCase("LoadDriver"):           GetFullPrivilegeName = SE_LOAD_DRIVER_NAME
        Case UCase("MachineAccount"):       GetFullPrivilegeName = SE_MACHINE_ACCOUNT_NAME
    End Select
    
End Function

Private Function GetStatusLong(ByVal Status As Boolean) As Long
    If Status = True Then GetStatusLong = SE_PRIVILEGE_ENABLED Else GetStatusLong = SE_PRIVILEGE_DISBALED
End Function
