VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "File"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : File
' DateTime  : 30/12/2006 01:33
' Author    : Vb System Library
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
' Purpose   : Objet Fichier
'---------------------------------------------------------------------------------------

'---------------------------------------------------------------------------------------
'
' Proprits
'       [statiques]
'   FullPath
'   Name
'   Path
'   Extension
'       [dynamiques]
'   Exists
'
' Mthodes
'   GetFileByFullPath
'   RefreshInfos
'   Delete
'
'---------------------------------------------------------------------------------------

Option Explicit

Private clsFile As New clsFiles

' Les infos sur ce fichier
Private tabInfos(0 To 4) As Variant

' Les diffrentes infos du fichier
Private Enum enumFileInfo
    efileFullPath = 0                               ' Le chemin d'accs complet au fichier
    efileName = 1                                   ' Le nom du fichier seulement
    efilePath = 2                                   ' Le dossier dans lequel se trouve le fichier
    efileExtension = 3                              ' L'extension du fichier
    efileExists = 4                                 ' Si le fichier existe ou pas
End Enum


'---------------------------------------------------------------------------------------
' Les mthodes
'---------------------------------------------------------------------------------------


' Retrouve le fichier  partir de son chemin d'accs
' [Optionnel] RefreshInfos : Active ou non le rafraichissement des infos dynamiques du processus
Public Sub GetFileByFullPath(ByRef FullPath As String, Optional ByVal bRefreshInfos As Boolean = False)
    tabInfos(efileFullPath) = FullPath
    ' Les informations statiques
    tabInfos(efileName) = clsFile.GetFileNameFromFullPath(FullPath)
    tabInfos(efilePath) = clsFile.GetPathFromFullPath(FullPath)
    tabInfos(efileExtension) = clsFile.GetFileExtension(FullPath)
    ' Les informations dynamiques
    If bRefreshInfos = True Then RefreshInfos
End Sub


' Rafraichit les proprits
Public Sub RefreshInfos()
    Dim FullPath As String
    FullPath = tabInfos(efileFullPath)
    tabInfos(efileExists) = clsFile.FileExists(FullPath)
End Sub


' Supprime le fichier
Public Sub Delete()
     clsFile.KillFile CStr(tabInfos(efileFullPath))
End Sub


' Dessine l'icone du fichier en 16x16
Public Sub PaintIcon16(ByVal hDC As Long)
     clsFile.PaintFileIcon16 CStr(tabInfos(efileFullPath)), hDC
End Sub


' Dessine l'icone du fichier en 32x32
Public Sub PaintIcon32(ByVal hDC As Long)
     clsFile.PaintFileIcon32 CStr(tabInfos(efileFullPath)), hDC
End Sub


'---------------------------------------------------------------------------------------
' Les proprits
'---------------------------------------------------------------------------------------

Public Property Get FullPath() As String
    FullPath = tabInfos(efileFullPath)
End Property

Public Property Get Name() As String
    Name = tabInfos(efileName)
End Property

Public Property Get Path() As String
    Path = tabInfos(efilePath)
End Property

Public Property Get Extension() As String
    Extension = tabInfos(efileExtension)
End Property

Public Property Get Exists() As Boolean
    Exists = tabInfos(efileExists)
End Property
