VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ListProcesses"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : ListProcesses
' DateTime  : 30/11/2006 17:16
' Author    : Vb System Library
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
' Purpose   : Contient une liste de processus
'---------------------------------------------------------------------------------------

'---------------------------------------------------------------------------------------
'
' Proprits
'   Window
'   Count
'
' Mthodes
'   RefreshList
'   RefreshItemInfos
'
'---------------------------------------------------------------------------------------

Option Explicit


' Les Processus (de 1  nbProcess)
Private colProcess As Collection

Private clsProcess As New clsProcesses


Private Sub Class_Initialize()
    Set colProcess = New Collection
End Sub

Private Sub Class_Terminate()
    Set colProcess = Nothing
End Sub


'---------------------------------------------------------------------------------------
' Les proprits
'---------------------------------------------------------------------------------------


' Renvoie un item de la liste
Public Property Get Process(ByVal Index As Long) As Process
    Set Process = colProcess.Item(Index)
End Property


' Le nombre de processus
Public Property Get Count() As Long
    Count = colProcess.Count
End Property


'---------------------------------------------------------------------------------------
' Procedure : RefreshItemInfos
' DateTime  : 09/03/2007 22:36
' Author    : Vb System Library
' Purpose   : Rafraichit toutes les informations d'un item de la liste
' Params    :
'---------------------------------------------------------------------------------------
Public Sub RefreshItemInfos()
    Dim tempProcess         As Process
    For Each tempProcess In colProcess
        tempProcess.RefreshInfos
    Next
End Sub


'---------------------------------------------------------------------------------------
' Procedure : RefreshList
' DateTime  : 30/11/2006 17:19
' Author    : Vb System Library
' Purpose   : Rafraichit la liste des processus
' Params    :   [Optionnel] RefreshItemInfos : Si activ, les informations des processus seront rafraichies
'                                               Sinon elles ne seront PAS rafraichies (PAR DEFAUT)
'               Les parametres suivants dfinissent le filtre de la liste :
'               [Optionnel] ID : ID du processus
'               [Optionnel] Name : Nom des processus
'               [Optionnel] ParentProcessID : ID du processus parent
'---------------------------------------------------------------------------------------
Public Sub RefreshList(Optional ByVal RefreshItemInfos As Boolean = False, Optional ByVal ID As Long = -1, Optional ByVal Name As String = "", Optional ByVal ParentProcessID As Long = -1)
    Dim tabProcessID()      As Long
    Dim tempProcess         As Process
    Dim T                   As Long
    Dim Valide              As Boolean
    ' Vide la liste
    For Each tempProcess In colProcess
        colProcess.Remove 1
    Next
    ' Dresse la liste des process
    clsProcess.GetProcessIDList tabProcessID()
    For T = LBound(tabProcessID) To UBound(tabProcessID)
        ' Cre l'objet processus
        Set tempProcess = New Process
        tempProcess.GetProcessByID tabProcessID(T), RefreshItemInfos
        ' Si le processus rpond aux critres
        Valide = True
        If (ID <> -1) And (tempProcess.ID <> ID) Then Valide = False
        If (Name <> "") And (tempProcess.Name <> Name) Then Valide = False
        If (ID <> -1) And (tempProcess.ParentProcessID <> ParentProcessID) Then Valide = False
        ' Ajoute le processus
        If Valide = True Then
            colProcess.Add tempProcess
        End If
        Set tempProcess = Nothing
    Next T
End Sub
